# Hunter's Damage Info Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/damage_info/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load damage_info
#
################################################################################
# PLEASE DO NOT MODIFY THIS FILE TO CHANGE YOUR CONFIG, SEE damage_info.cfg    #
################################################################################
#import EventScripts
import es
#import Libraries
import gamethread
import cmdlib
import cfglib
import playerlib
import settinglib

# Addon Information
info = es.AddonInfo()
info.name = "Damage Info"
info.version = "2.0.1"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "This scriptaddon adds hitsounds to your server"
info.basename = "damage_info"

hunter_damage_info_ver   = info.version
hunter_damage_info_text  = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.250i+ (Python Version)'

# Server Variables
damage_info_config       = cfglib.AddonCFG('%s/damage_info.cfg' % es.getAddonPath('damage_info'))
damage_info_savetime     = damage_info_config.cvar('damage_info_savetime', '30', 'How much days should inactive users be stored, before their settings get deleted? ( default = 30 )')
damage_info_config.write()

# Global Variables
damage_info_hitgroups    = {1:'Head',2:'Chest',3:'Stomach',4:'Left Arm',5:'Right Arm',6:'Left Leg',7:'Right Leg'}

# Settinglib Object
damage_info_setting      = settinglib.create('damagedisplay', 'Damage Info Setting', 'toggle')

def load():
    public = es.ServerVar('hu_di', info.version, info.name)
    public.makepublic()
    
    cmdlib.registerSayCommand('!damage', _say_cmd, 'Damage Info Setting')

    damage_info_setting.addoption('hit', 'Hit Damage')
    damage_info_setting.addoption('impressive', 'Impressive Info')
    damage_info_setting.setdefault('hit', '1')
    damage_info_setting.setdefault('impressive', '1')
    damage_info_setting.addsound('ui/buttonclick.wav')

    es.log(hunter_damage_info_text)
    es.msg('#multi', '#green[DamageInfo] #defaultLoaded')
    
def unload():
    cmdlib.unregisterSayCommand('!damage')

    es.msg('#multi', '#green[DamageInfo] #defaultUnloaded')
    
def es_map_start(event_var):
    damage_info_setting.clear(int(damage_info_savetime)*86400)

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_damage_info_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_damage_info_text)

def player_activate(event_var):
    damage_info_setting.updateTime(int(event_var['userid']))
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_damage_info_text))
    gamethread.delayed(15, es.tell, (int(event_var['userid']), '#multi', '#green[DamageInfo] #defaultSay \'!damage\' for settings menu'))

def player_disconnect(event_var):
    damage_info_setting.updateTime(int(event_var['userid']))

def player_hurt(event_var):
    userid = int(event_var['userid'])
    attackerid = int(event_var['attacker'])
    if (userid > 0) and (attackerid > 0):
        if not es.isbot(attackerid):
            if damage_info_setting.get('hit', attackerid):
                if int(event_var['hitgroup']) in damage_info_hitgroups:
                    bodypart = damage_info_hitgroups[int(event_var['hitgroup'])]
                else:
                    bodypart = 'Body'
                es.tell(attackerid, '#multi', '#greenYou hit #lightgreen'+str(event_var['es_username'])+' #greenat #lightgreen'+str(bodypart)+' #green- #lightgreen'+str(event_var['health'])+' #greenHP remaining')
        if int(event_var['es_userteam']) != int(event_var['es_attackerteam']):
            damage = int(event_var['dmg_health']) + int(event_var['dmg_armor'])
            if damage >= 100:
                for target in playerlib.getUseridList('#human'):
                    if damage_info_setting.get('impressive', target): 
                        es.tell(target, '#multi', '#greenImpressive #lightgreen'+str(event_var['es_attackername'])+' #green- #lightgreen'+str(damage)+' #greendamage')

def _say_cmd(userid, args):
    damage_info_setting.send(userid)
